local dungeon = {}
local rng = love.math.newRandomGenerator(os.time())

function love.load()
end

function love.update(dt)
end

function love.draw()
	love.graphics.print("Press Enter to generate a new layout.", 200, 10)
	love.graphics.print("Press Backspace for current seed and state data.", 200, 25)
	for i = 1, #dungeon do
		for j = 1, #dungeon do
			love.graphics.print(tostring(dungeon[i][j]), 15 * j, 15 * i)
		end
	end
end

function love.keypressed(key, scancode, isrepeat)
	if key == "return" then
		randomize(17, 7, 10)
	end
	if key == "backspace" then
		print(rng:getSeed().."\t"..rng:getState())
	end
end

function randomize(rooms, minSize, maxSize)
	local size = rng:random(minSize,maxSize)
	local roomCount = 1
	print(size.."x"..size)
	dungeon = {}
	for i=1,size do 
		dungeon[i] = {}
		for j=1,size do
			dungeon[i][j] = 0
		end
	end
	dungeon[math.floor(size/2)][math.floor(size/2)] = 1
	while roomCount < rooms do
		local x = rng:random(1,size)
		local y = rng:random(1,size)
		if approvedPossition(dungeon, x, y) then
			dungeon[y][x] = 2
			roomCount = roomCount + 1
		end
	end
end

function approvedPossition(map, x, y)
	local adjRooms = 0
	if map[y][x] == 0 then
		for i=-1,1,2 do
			if map[math.min(math.max(y+i, 1), #map)][x] ~= 0 then adjRooms = adjRooms + 1 end
			if map[y][math.min(math.max(x+i, 1), #map)] ~= 0 then adjRooms = adjRooms + 1 end
		end
		if 1 <= adjRooms and adjRooms < 3 then return true end
	end
	return false
end